用文件更新文档deprecated
已弃用。改用 更新文档。通过上传新文件更新文档,然后重新索引。
1 min read
post/datasets/{dataset_id}/documents/{document_id}/update-by-file
Request example
curl --request POST \
--url https://api.dify.ai/v1/datasets/{dataset_id}/documents/{document_id}/update-by-file \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: multipart/form-data' \
--form 'data={"doc_form":"text_model","doc_language":"English","process_rule":{"mode":"automatic"}}' \
--form 'file=<file>'import requests
url = "https://api.dify.ai/v1/datasets/{dataset_id}/documents/{document_id}/update-by-file"
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "multipart/form-data",
}
files = {
"data": (None, "{\"doc_form\":\"text_model\",\"doc_language\":\"English\",\"process_rule\":{\"mode\":\"automatic\"}}"),
"file": (None, "<file>"),
}
response = requests.request("POST", url, headers=headers, files=files)
print(response.text)const form = new FormData();
form.append('data', '{"doc_form":"text_model","doc_language":"English","process_rule":{"mode":"automatic"}}');
form.append('file', '<file>');
const response = await fetch('https://api.dify.ai/v1/datasets/{dataset_id}/documents/{document_id}/update-by-file', {
method: 'POST',
headers: {
'Authorization': 'Bearer <token>',
'Content-Type': 'multipart/form-data'
},
body: form
});
const data = await response.json();
console.log(data);<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => 'https://api.dify.ai/v1/datasets/{dataset_id}/documents/{document_id}/update-by-file',
CURLOPT_RETURNTRANSFER => true,
CURLOPT_CUSTOMREQUEST => 'POST',
CURLOPT_POSTFIELDS => ['data' => '{"doc_form":"text_model","doc_language":"English","process_rule":{"mode":"automatic"}}', 'file' => '<file>'],
CURLOPT_HTTPHEADER => [
'Authorization: Bearer <token>',
'Content-Type: multipart/form-data',
],
]);
$response = curl_exec($curl);
curl_close($curl);
echo $response;package main
import (
"fmt"
"io"
"net/http"
"strings"
)
func main() {
url := "https://api.dify.ai/v1/datasets/{dataset_id}/documents/{document_id}/update-by-file"
payload := strings.NewReader("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\"doc_form\":\"text_model\",\"doc_language\":\"English\",\"process_rule\":{\"mode\":\"automatic\"}}\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"file\"\r\n\r\n<file>\r\n-----011000010111000001101001--\r\n")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "multipart/form-data; boundary=---011000010111000001101001")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpRequest request = HttpRequest.newBuilder()
.uri(URI.create("https://api.dify.ai/v1/datasets/{dataset_id}/documents/{document_id}/update-by-file"))
.header("Authorization", "Bearer <token>")
.header("Content-Type", "multipart/form-data; boundary=---011000010111000001101001")
.method("POST", HttpRequest.BodyPublishers.ofString("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"data\"\r\n\r\n{\"doc_form\":\"text_model\",\"doc_language\":\"English\",\"process_rule\":{\"mode\":\"automatic\"}}\r\n-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"file\"\r\n\r\n<file>\r\n-----011000010111000001101001--\r\n"))
.build();
HttpResponse<String> response = HttpClient.newHttpClient()
.send(request, HttpResponse.BodyHandlers.ofString());
System.out.println(response.body());require 'uri'
require 'net/http'
url = URI('https://api.dify.ai/v1/datasets/{dataset_id}/documents/{document_id}/update-by-file')
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = url.scheme == 'https'
request = Net::HTTP::Post.new(url)
request['Authorization'] = 'Bearer <token>'
request['Content-Type'] = 'multipart/form-data'
request.set_form([['data', '{"doc_form":"text_model","doc_language":"English","process_rule":{"mode":"automatic"}}'], ['file', '<file>']], "multipart/form-data")
response = http.request(request)
puts response.read_bodyResponse
{
"batch": "20250306150245647595",
"document": {
"archived": false,
"created_at": 1741267200,
"created_by": "ad313dd6-ef04-4dd1-a5b0-c0f0b9e2e7e4",
"created_from": "api",
"data_source_detail_dict": {
"upload_file": {
"created_at": 1741267200,
"created_by": "ad313dd6-ef04-4dd1-a5b0-c0f0b9e2e7e4",
"extension": "txt",
"id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890",
"mime_type": "text/plain",
"name": "guide.txt",
"size": 2048
}
},
"data_source_info": {
"upload_file_id": "a1b2c3d4-e5f6-7890-abcd-ef1234567890"
},
"data_source_type": "upload_file",
"dataset_process_rule_id": "e1f2a3b4-c5d6-7890-ef12-345678901234",
"disabled_at": null,
"disabled_by": null,
"display_status": "available",
"doc_form": "text_model",
"doc_metadata": [],
"enabled": true,
"error": null,
"hit_count": 0,
"id": "a8e0e5b5-78c6-4130-a5ce-25feb0e0b4ac",
"indexing_status": "completed",
"name": "guide.txt",
"need_summary": false,
"position": 1,
"summary_index_status": null,
"tokens": 512,
"word_count": 350
}
}{
"code": "filename_not_exists_error",
"message": "The specified filename does not exist.",
"status": 400
}{
"code": "invalid_param",
"message": "Document is not available",
"status": 400
}{
"code": "provider_not_initialize",
"message": "No valid model provider credentials found. Please go to Settings -> Model Provider to complete your provider credentials.",
"status": 400
}{
"code": "too_many_files",
"message": "Only one file is allowed.",
"status": 400
}{
"code": "forbidden",
"message": "Dataset api access is not enabled.",
"status": 403
}{
"code": "forbidden",
"message": "The capacity of the vector space has reached the limit of your subscription.",
"status": 403
}{
"code": "forbidden",
"message": "Sorry, you have reached the knowledge base request rate limit of your subscription.",
"status": 403
}{
"code": "forbidden",
"message": "The API key is not authorized to access this knowledge base.",
"status": 403
}{
"code": "not_found",
"message": "Dataset not found.",
"status": 404
}{
"code": "not_found",
"message": "Document not found.",
"status": 404
}{
"code": "file_too_large",
"message": "File size exceeded.",
"status": 413
}{
"code": "unsupported_file_type",
"message": "File type not allowed.",
"status": 415
}{
"code": "service_unavailable",
"message": "Unable to verify vector space usage right now. Please try again later.",
"status": 503
}post/datasets/{dataset_id}/documents/{document_id}/update-by-file
Authorization
Path parameters
知识库 ID,通过 获取知识库列表 获取。使用限定范围的密钥时,从 Dify 页面 URL 复制 ID。
文档 ID。从 获取知识库的文档列表 获取。
Body
multipart/form-dataResponses
application/json
文档更新成功。
用于跟踪索引进度的批次 ID。
Show child attributesHide child attributes
文档是否已归档。
创建时间戳(Unix 纪元,单位为秒)。
创建该文档的用户 ID。
文档来源。通过 API 创建时为
api,通过 UI 创建时为 web。详细的数据源信息,包括文件详情。
原始数据源信息,随
data_source_type 而异。文档的创建方式。文件上传为
upload_file,Notion 导入为 notion_import。应用于该文档的处理规则 ID。
文档被禁用的时间戳。启用时为
null。禁用该文档的用户 ID。启用时为
null。基于
indexing_status 和 enabled 状态派生的面向用户的显示状态。文档分块模式。
text_model 表示标准文本分块,hierarchical_model 表示父子结构,qa_model 表示问答对提取。分配给该文档的元数据值。
该文档是否启用检索。
索引失败时的错误消息。无错误时为
null。该文档在检索查询中被匹配的次数。
文档的唯一标识符。
当前索引状态。
waiting 表示排队中,parsing 表示正在提取内容,cleaning 表示正在去噪,splitting 表示正在分块,indexing 表示正在构建向量,completed 表示就绪,error 表示失败,paused 表示手动暂停。文档名称。
是否需要为该文档生成摘要。
文档在列表中的显示位置。
该文档的摘要索引状态。未配置摘要索引时为
null。文档中的令牌总数。
文档的总字数。